searchNodes=[{"doc":"GCSSign helps signing URLs and HTTP form requests for Google Cloud Storage. This library provides logic for signing URLs and POST policies locally with JSON service account key credentials. Examples Signing URLs GCSSign.sign_url_v4/2 can be used to sign URLs. Signed URLs give limited, temporary access to a resource in a Google Cloud Storage bucket. Google's documentation goes into further detail on the usage and best practices of signed URLs. # Use a service account key credentials = &quot;GCP_CREDENTIALS&quot; |&gt; System . fetch_env! ( ) |&gt; Jason . decode! ( ) # Sign a simple URL sign_opts = [ bucket : &quot;demo-bucket&quot; , key : &quot;test.txt&quot; ] url = GCSSign . sign_url_v4 ( credentials , sign_opts ) # Sign a URL with custom expiration time sign_opts = [ bucket : &quot;demo-bucket&quot; , key : &quot;test.txt&quot; , expires_in : 60 ] url = GCSSign . sign_url_v4 ( credentials , sign_opts ) # Sign a URL with custom headers headers = [ # Or use https://hex.pm/packages/content_disposition # {&quot;response-content-disposition&quot;, ContentDisposition.format(disposition: :attachment, filename: &quot;file.txt&quot;)}, { &quot;response-content-disposition&quot; , &quot;inline; filename= \\&quot; file.txt \\&quot; ; filename*=UTF-8&#39;&#39;file.txt&quot; } , { &quot;response-content-type&quot; , &quot;text/plain&quot; } ] sign_opts = [ bucket : &quot;demo-bucket&quot; , key : &quot;test.txt&quot; , expires_in : 60 ] url = GCSSign . sign_url_v4 ( credentials , sign_opts ) Signing XML POST Policies Signed POST policies can be used to allow external parties limited upload access to a bucket. A policy document can be used to limit in which bucket, with what key a file can be uploaded, and it supports setting file-size limits. GCSSign.sign_post_policy_v4/2 can be used to sign a POST policy. It requires a bucket and key and returns a map with a URL and a map of fields that should be passed as parameters in the upload request. Google's documentation describes how this can be used to perform a multipart upload. # Use a service account key credentials = &quot;GCP_CREDENTIALS&quot; |&gt; System . fetch_env! ( ) |&gt; Jason . decode! ( ) # Sign a simple URL sign_opts = [ expires_in : 600 , bucket : &quot;demo-bucket&quot; , key : &quot;test.txt&quot; , fields : %{ &quot;content-type&quot; =&gt; &quot;text/plain&quot; , &quot;cache-control&quot; =&gt; &quot;public, max-age=31536000&quot; } , conditions : [ [ &quot;content-length-range&quot; , 0 , 2_000_000 ] ] ] { :ok , policy } = GCSSign . sign_post_policy_v4 ( credentials , sign_opts ) Authorizer options Google Cloud Storage accepts two different options for passing the credential scope's authorizer: client_id : The ID of the service account key client_email : The service account email GCSSign will use the client_id by default because it exposes the least information when used in XML POST with HTML forms. You can optionally set authorizer: :client_email in sign_opts to make the credential scope use client_email . Read more about authorizer in Google's documentation","ref":"GCSSign.html","title":"GCSSign","type":"module"},{"doc":"Signs a POST policy Signed POST policies can be used to allow external parties limited upload access to a bucket. A policy document can be used to limit in which bucket, with what key a file can be uploaded, and it supports setting file-size limits. Google's documentation describes how this can be used to perform a multipart upload. Options :bucket ( String.t/0 ) - The name of the GCS bucket. :key ( String.t/0 ) - The key to the file in the bucket, without leading slash. :authorizer ( authorizer/0 ) - The type of authorizer to use, see &quot; Authorizer &quot; in the module documentation. Defaults to :client_id :expires_in ( integer/0 ) - Time in seconds that the POST policy should stay valid for. Defaults to 3600 (1 hour). Cannot exceed 7 days or 604800 seconds. :conditions ( conditions/0 ) - Additional conditions to impose on the policy, see &quot;Conditions&quot; below. :fields ( fields/0 ) - Additional fields to include in the signed policy, see &quot;Fields&quot; below. :utc_now ( Calendar.datetime/0 ) - Optionally uses a different time instead of DateTime.utc_now/0 . Conditions Conditions can be in either 3-element list format, or as a map: conditions = [ [ &quot;eq&quot; , &quot;$x-custom-header&quot; , &quot;value&quot; ] , [ &quot;content-length-range&quot; , 0 , 20_000_000 ] , %{ &quot;x-goog-meta-tenant&quot; =&gt; &quot;tenant-1&quot; } ] To learn more about the supported conditions, see Google's documentation . Fields Additional fields supported by GCS can be passed as :fields and will be signed accordingly. fields = %{ &quot;cache-control&quot; =&gt; &quot;public, max-age=31536000&quot; &quot;content-type&quot; =&gt; &quot;text/plain&quot; , }","ref":"GCSSign.html#sign_post_policy_v4/2","title":"GCSSign.sign_post_policy_v4/2","type":"function"},{"doc":"Signs a URL with V4 signing process Signed URLs give limited permission and time to make an authorized request for anyone in possession of the URL without requiring the requester to have a Google account with access to the resource. Signed URLs contain authentication information in the query string to authenticate a request on behalf of the service account used to sign the URL. To learn more about signed URLs, see Google's documentation . Options :bucket ( String.t/0 ) - The name of the GCS bucket. :key ( String.t/0 ) - The key to the file in the bucket, without leading slash. :authorizer ( authorizer/0 ) - The type of authorizer to use, see &quot; Authorizer &quot; in the module documentation. Defaults to :client_id :expires_in ( integer/0 ) - Time in seconds that the POST policy should stay valid for. Defaults to 3600 (1 hour). Cannot exceed 7 days or 604800 seconds. :method ( http_verb/0 ) - The key to the file in the bucket, without leading slash. Default: &quot;GET&quot; :headers ( headers/0 ) - Headers that should be included in the request. Defaults to the host header. :payload ( String.t/0 or nil ) - The request body required when making the request. Defaults to nil . nil is converted to UNSIGNED-PAYLOAD , meaning the payload isn't signed. :query ( query/0 ) - The query parameters required in the request. :host ( String.t/0 ) - The cloud storage hostname to use. Defaults to &quot;storage.googleapis.com&quot; . When set to a custom hostname, the path will not contain the bucket name to allow for Custom CNAME or Backend buckets in a loadbalancer setup. :utc_now ( Calendar.datetime/0 ) - Optionally uses a different time instead of DateTime.utc_now/0 .","ref":"GCSSign.html#sign_url_v4/2","title":"GCSSign.sign_url_v4/2","type":"function"},{"doc":"An authorizer key type. Defaults to :client_id , but can optionally be set to :client_email to use the service account's email as authorizer. See &quot;Authorizer&quot; in the module documentation for more.","ref":"GCSSign.html#t:authorizer/0","title":"GCSSign.authorizer/0","type":"type"},{"doc":"Shared options for both URL and POST policy signing","ref":"GCSSign.html#t:common_option/0","title":"GCSSign.common_option/0","type":"type"},{"doc":"A condition for a POST policy. See Google's documentation for more. Examples # Exact matching [ &quot;eq&quot; , &quot;$x-custom-header&quot; , &quot;value&quot; ] %{ &quot;x-goog-meta-tenant&quot; =&gt; &quot;tenant-1&quot; } # Starts with [ &quot;starts-with&quot; , &quot;$key&quot; , &quot;some/prefix/key&quot; ] [ &quot;starts-with&quot; , &quot;$key&quot; , &quot;&quot; ] # no restrictions on value # Content-Length range [ &quot;content-length-range&quot; , 0 , 20_000_000 ]","ref":"GCSSign.html#t:condition/0","title":"GCSSign.condition/0","type":"type"},{"doc":"A list of conditions.","ref":"GCSSign.html#t:conditions/0","title":"GCSSign.conditions/0","type":"type"},{"doc":"The parsed JSON service account key. Contains the private_key and client_id / client_email .","ref":"GCSSign.html#t:credentials/0","title":"GCSSign.credentials/0","type":"type"},{"doc":"Additional fields for a signed POST policy. Supported fields","ref":"GCSSign.html#t:fields/0","title":"GCSSign.fields/0","type":"type"},{"doc":"A list of headers. Headers are case-insensitive. The same header key can appear multiple times and will be handled accordingly according to the documenation .","ref":"GCSSign.html#t:headers/0","title":"GCSSign.headers/0","type":"type"},{"doc":"A HTTP method. Accepts atoms and case-insensitive strings. Every method will be uppercased and converted to a string before being encoded.","ref":"GCSSign.html#t:http_verb/0","title":"GCSSign.http_verb/0","type":"type"},{"doc":"Options specific for POST policy signing","ref":"GCSSign.html#t:post_policy_option/0","title":"GCSSign.post_policy_option/0","type":"type"},{"doc":"A query string in the form of a list of tuples. Optionally accepts atoms as keys that will be transformed to strings. Only strings are allowed as values.","ref":"GCSSign.html#t:query/0","title":"GCSSign.query/0","type":"type"},{"doc":"A signed POST policy","ref":"GCSSign.html#t:signed_policy/0","title":"GCSSign.signed_policy/0","type":"type"},{"doc":"Options specific for URL signing","ref":"GCSSign.html#t:url_option/0","title":"GCSSign.url_option/0","type":"type"}]